require("middleclass")

Pushable = {} --class("Pushable")
function Pushable:pushed(by)
  print("I (" .. self.name)
  print("am being pushed by " .. by.name)
end


Entity = class("Entity")
function Entity:initialize(name)
  self.name = name
end


Block = class("Block", Entity)
Block:include(Pushable)
function Block:initialize(name)
  Entity.initialize(self, name)
end


Tree = class("Tree", Entity)
function Tree:initialize(name)
  Entity.initialize(self, name)
end


function love.load()
  b = Block:new('blocky')
  t = Tree:new('tree')
  p = Entity:new('the player')
end


function love.draw()
  b:pushed(p)
  t:pushed(p)
end

